#define TI92PLUS
//#define TI89

//#include <doors.h>
#include <nostub.h>


#include <all.h>
#include "sg_lang.h"
#include "dlgstruct.h"

/*

TO ADD:
* More play modes (action, versus, advanced puzzle?)
* Find and use a better rand() routine. Maybe it's possible to use the one in the ROM?

*/

#define NO_OF_HISCORES 5

#ifdef TI92PLUS
  int _ti92plus;
  #define NUMBER_WIDTH 4
  #define FONT 1
  #define FONT_HEIGHT 8
  #define ABOUT_WIDTH ABOUT_WIDTH_92PLUS
  #define OPTIONS_WIDTH OPTIONS_WIDTH_92PLUS
  #define LCD_WIDTH 240
  #define LCD_HEIGHT 128
  enum buttons {BUTTON_NONE=0,BUTTON_ACTION=268,BUTTON_ESC=264,
                BUTTON_RIGHT=340,BUTTON_LEFT=337,BUTTON_DOWN=344,BUTTON_UP=338};
#endif

#ifdef TI89
  int _ti89;
  #define NUMBER_WIDTH 6
  #define FONT 0
  #define FONT_HEIGHT 6
  #define ABOUT_WIDTH ABOUT_WIDTH_89
  #define OPTIONS_WIDTH OPTIONS_WIDTH_89
  #define LCD_WIDTH 160
  #define LCD_HEIGHT 100
  enum buttons {BUTTON_NONE=0,BUTTON_ACTION=268,BUTTON_ESC=264,
                BUTTON_RIGHT=344,BUTTON_LEFT=338,BUTTON_DOWN=340,BUTTON_UP=337};
#endif

#define MAX_PLAYFIELD_WIDTH (LCD_WIDTH/5)
#define MAX_PLAYFIELD_HEIGHT ((LCD_HEIGHT/5)-1)

enum MainMenu {MAINMENU_ESC,MAINMENU_NEWGAME,MAINMENU_OPTIONS,MAINMENU_HIGHSCORES,MAINMENU_ABOUT,MAINMENU_QUIT};

WORD GreyscaleData[2] = {0,0};
WORD GreyscalePhase = 0;
void *GreyPlane[2] = {NULL,NULL};

int randseed = 0x4247;
unsigned int HW = 1;

struct {
  int stonesize;
  int playmode;
} Mode = {3,0};

/**********************
* HIGHSCORE LIST DATA *
**********************/
typedef struct {
  char name[12];
  unsigned long score;
} HIGHSCORE;

HIGHSCORE highscores[7][5] =
  {{{"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0}},
   {{"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0}},
   {{"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0}},
   {{"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0}},
   {{"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0}},
   {{"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0}},
   {{"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0},
    {"Prefect\0    ",0}}};

/***********
* GFX DATA *
***********/
typedef struct {
  unsigned int size;
  void *data;
} STONE_DATA;

WORD stones1[] =
  {0x0fff,
   0x6000,0xb000,0xf000,0x6000,
   0x9000,0x0000};
WORD stones2[] =
  {0x07ff,
   0x7000,0xd800,0xb800,0xf800,0x7000,
   0x8800,0x0000,0x0000};
WORD stones3[] =
  {0x01ff,
   0x3800,0x6c00,0xde00,0xbe00,0xfe00,0x7c00,0x3800,
   0xc600,0x8200,0x0000,0x0000};
WORD stones4[] =
  {0x007f,
   0x3e00,0x6f00,0xdf80,0xbf80,0xff80,0xff80,0xff80,0x7f00,0x3e00,
   0xc180,0x8080,0x0000,0x0000,0x0000};
WORD stones5[] =
  {0x001f,
   0x1f00,0x3780,0x6fc0,0xdfe0,0xbfe0,0xffe0,0xffe0,0xffe0,0x7fc0,0x3f80,0x1f00,
   0xe0e0,0xc060,0x8020,0x0000,0x0000,0x0000};
WORD stones6[] =
  {0x0007,
   0x0f80,0x39e0,0x67f0,0x5ff0,0xdff8,0xbff8,0xbff8,0xfff8,0xfff8,0x7ff0,0x7ff0,0x3fe0,0x0f80,
   0xf078,0xc018,0x8008,0x8008,0x0000,0x0000,0x0000};
WORD stones7[] =
  {0x0001,
   0x07c0,0x1cf0,0x33f8,0x6ffc,0x5ffc,0xdffe,0xbffe,0xbffe,0xfffe,0xfffe,0x7ffc,0x7ffc,0x3ff8,0x1ff0,0x07c0,
   0xf83e,0xe00e,0xc006,0x8002,0x8002,0x0000,0x0000,0x0000};
STONE_DATA stones[7] =
  {{4,stones1},
   {5,stones2},
   {7,stones3},
   {9,stones4},
   {11,stones5},
   {13,stones6},
   {15,stones7}};

/*****************
* MAIN MENU DATA *
*****************/
BEGIN_POPUP(MainMenuPopup,MainMenu_Title,5,5,128)
  BEGIN_POPUP_MENU(MainMenu_Main)
    ADD_POPUP_TEXT(MainMenu_Main_Entry1,MainMenu_Title,MainMenu_Main_Entry1Str,1)
    ADD_POPUP_TEXT(MainMenu_Main_Entry2,MainMenu_Title,MainMenu_Main_Entry2Str,2)
    ADD_POPUP_TEXT(MainMenu_Main_Entry3,MainMenu_Title,MainMenu_Main_Entry3Str,3)
    ADD_POPUP_TEXT(MainMenu_Main_Entry4,MainMenu_Title,MainMenu_Main_Entry4Str,4)
    ADD_POPUP_TEXT(MainMenu_Main_Entry5,MainMenu_Title,MainMenu_Main_Entry5Str,5)
  END_POPUP_MENU
END_POPUP(MainMenuPopup)
char MainMenu_Title[] = GAMESTRING;
char MainMenu_Main_Entry1Str[] = LANG_NEW_GAME;
char MainMenu_Main_Entry2Str[] = LANG_OPTIONS;
char MainMenu_Main_Entry3Str[] = LANG_HIGHSCORES;
char MainMenu_Main_Entry4Str[] = LANG_ABOUT;
char MainMenu_Main_Entry5Str[] = LANG_QUIT;

/*********************
* OPTIONS SIZE POPUP *
*********************/
BEGIN_POPUP(OptionsSizePopup,OptionsSizePopup_Title,7,7,128)
  BEGIN_POPUP_MENU(OptionsSizePopup_Main)
    ADD_POPUP_TEXT(OptionsSizePopup_Main_Entry1,OptionsSizePopup_Title,OptionsSizePopup_Main_Entry1Str,1)
    ADD_POPUP_TEXT(OptionsSizePopup_Main_Entry2,OptionsSizePopup_Title,OptionsSizePopup_Main_Entry2Str,2)
    ADD_POPUP_TEXT(OptionsSizePopup_Main_Entry3,OptionsSizePopup_Title,OptionsSizePopup_Main_Entry3Str,3)
    ADD_POPUP_TEXT(OptionsSizePopup_Main_Entry4,OptionsSizePopup_Title,OptionsSizePopup_Main_Entry4Str,4)
    ADD_POPUP_TEXT(OptionsSizePopup_Main_Entry5,OptionsSizePopup_Title,OptionsSizePopup_Main_Entry5Str,5)
    ADD_POPUP_TEXT(OptionsSizePopup_Main_Entry6,OptionsSizePopup_Title,OptionsSizePopup_Main_Entry6Str,6)
    ADD_POPUP_TEXT(OptionsSizePopup_Main_Entry7,OptionsSizePopup_Title,OptionsSizePopup_Main_Entry7Str,7)
  END_POPUP_MENU
END_POPUP(OptionsSizePopup)
char OptionsSizePopup_Title[] = LANG_SIZE;
char OptionsSizePopup_Main_Entry1Str[] = LANG_NANO;
char OptionsSizePopup_Main_Entry2Str[] = LANG_MICRO;
char OptionsSizePopup_Main_Entry3Str[] = LANG_MILLI;
char OptionsSizePopup_Main_Entry4Str[] = LANG_NORMAL;
char OptionsSizePopup_Main_Entry5Str[] = LANG_KILO;
char OptionsSizePopup_Main_Entry6Str[] = LANG_MEGA;
char OptionsSizePopup_Main_Entry7Str[] = LANG_GIGA;

/*********************
* OPTIONS MODE POPUP *
*********************/
BEGIN_POPUP(OptionsModePopup,OptionsModePopup_Title,1,1,128)
  BEGIN_POPUP_MENU(OptionsModePopup_Main)
    ADD_POPUP_TEXT(OptionsModePopup_Main_Entry1,OptionsModePopup_Title,OptionsModePopup_Main_Entry1Str,1)
  END_POPUP_MENU
END_POPUP(OptionsModePopup)
char OptionsModePopup_Title[] = LANG_MODE;
char OptionsModePopup_Main_Entry1Str[] = LANG_PUZZLE;

/**********************
* OPTIONS DIALOG DATA *
**********************/
BEGIN_DIALOG(OptionsDlg,Options_Title,3,OPTIONS_WIDTH,19+2*FONT_HEIGHT+2+4+FONT_HEIGHT,NoCallBack)
  ADD_DIALOG_TITLE(OptionsTitle,Options_Title,Options_Title,BT_NONE,BT_OK)
  ADD_DIALOG_POPUP(OptionsSize,Options_Title,Options_SizeStr,5,15,OptionsSizePopup,0)
  ADD_DIALOG_POPUP(OptionsMode,Options_Title,Options_ModeStr,5,15+FONT_HEIGHT,OptionsModePopup,0)
END_DIALOG(OptionsDlg)
char Options_Title[] = LANG_OPTIONS_MENU;
char Options_SizeStr[] = LANG_SIZE;
char Options_ModeStr[] = LANG_MODE;

/****************************
* NEW HIGHSCORE DIALOG DATA *
****************************/
BEGIN_DIALOG(NewHighscoreDlg,NewHighscore_Title,2,6+6*(sizeof(LANG_NAME)+1+13),19+FONT_HEIGHT+2+4+FONT_HEIGHT,NoCallBack)
  ADD_DIALOG_TITLE(NewHighscoreTitle,NewHighscore_Title,NewHighscore_Title,BT_NONE,BT_OK)
  ADD_DIALOG_REQUEST(NewHighscoreReq,NewHighscore_Title,NewHighscore_ReqStr,3,15,12,13,0)
END_DIALOG(NewHighscoreDlg)
char NewHighscore_Title[] = LANG_NEW_HIGHSCORE;
char NewHighscore_ReqStr[] = LANG_NAME;

/**********************
* "ABOUT" DIALOG DATA *
**********************/
BEGIN_DIALOG(AboutDlg,About_Title,3,ABOUT_WIDTH,21+FONT_HEIGHT+4+ABOUT_LINES*FONT_HEIGHT+4+FONT_HEIGHT,NoCallBack)
  ADD_DIALOG_TITLE(AboutTitle,About_Title,About_Title,BT_NONE,BT_OK)
  ADD_DIALOG_TEXT(AboutNameLine,About_Title,About_NameLineStr,2,14)
  ADD_DIALOG_TEXT(AboutLine1,About_Title,About_Line1Str,2,14+4+FONT_HEIGHT)
  ADD_DIALOG_TEXT(AboutLine2,About_Title,About_Line2Str,2,14+4+2*FONT_HEIGHT)
  ADD_DIALOG_TEXT(AboutLine3,About_Title,About_Line3Str,2,14+4+3*FONT_HEIGHT)
END_DIALOG(AboutDlg)
char About_Title[] = LANG_ABOUT_SOMEGAME;
char About_NameLineStr[] = LANG_ABOUT_NAMELINE;
char About_Line1Str[] = LANG_ABOUT_LINE1;
char About_Line1StrCont[] = LANG_ABOUT_LINE1_CONT;
char About_Line2Str[] = LANG_ABOUT_LINE2;
char About_Line3Str[] = LANG_ABOUT_LINE3;

/*******************************
* TI-GCC long div/mul routines *
*******************************/
asm("	__divsi3:
		move.w	#0x2a8*4,%d2          /* _ds32s32 */
	__div_entry:
		move.l	(4,%a7),%d1
		move.l	(8,%a7),%d0
		movea.l	0xc8,%a0
		movea.l	(%a0,%d2.w),%a0
		jsr	(%a0)
		move.l	%d1,%d0
		rts
	__modsi3:
		move.w	#0x2a9*4,%d2          /* _ms32s32 */
		jmp	__div_entry
	__udivsi3:
		move.w	#0x2aa*4,%d2          /* _du32u32 */
		jmp	__div_entry
	__umodsi3:
		move.w	#0x2ab*4,%d2          /* _mu32u32 */
		jmp	__div_entry");

/*****************************************************************
* Returns HW version (1 for HW1 calculators and 2 for HW2 calcs) *
*  Thanx to Julien Muchembled for the code                       *
*****************************************************************/
unsigned long GetHardwareVersion() {
  unsigned long hwpb, *rombase;
  rombase = (unsigned long *)((*(unsigned long *)0xC8) & 0x600000);
  hwpb = rombase[65];
  return (hwpb - (unsigned long)rombase  < 0x10000
          && *(unsigned short *)hwpb > 22 ?
          *(unsigned long *)(hwpb + 22) : 1);
}


/**************************
* unsigned long "sprintf" *
**************************/
char *ulsprintf(char *bufferend,unsigned long num) {
  *bufferend = 0;
  do {
    *(--bufferend) = '0' + (num % 10);
  } while(num /= 10);
  return bufferend;
}


/**************************
* RANDOM NUMBER GENERATOR *
**************************/
unsigned long z=362436069;
unsigned int rand(unsigned int max);
asm("	.even
	rand:
		move.w	z+2,%d0
		mulu.w	#36969,%d0
		add.w	z,%d0
		move.l	%d0,z

		mulu.w	4(%sp),%d0
		swap	%d0
		rts");

/*************************************************
* HARDWARE VERSION 1 GREYSCALE INTERRUPT HANDLER *
*************************************************/
asm("		.even
	GreyscaleInterrupt_HW1:
		movem.l		%a0-%a2/%d0-%d2,-(%sp)
		move.w		#0x2700,%sr
		move.w		GreyscalePhase,%d0
		beq		Greyscale_HW1_Wrap
		subq.w		#2,%d0
		move.w		%d0,GreyscalePhase
		lea		GreyscaleData,%a0
		move.w		0(%a0,%d0.w),(0x00600010)
		bra		Greyscale_HW1_Done
	Greyscale_HW1_Wrap:
		move.w		#2*2,GreyscalePhase
	Greyscale_HW1_Done:
		movem.l		(%sp)+,%a0-%a2/%d0-%d2
		rte");


/*************************************************
* HARDWARE VERSION 2 GREYSCALE INTERRUPT HANDLER *
*************************************************/
asm("		.even
	GreyscaleInterrupt_HW2:
		movem.l		%a0-%a6/%d0-%d7,-(%sp)
		move.w		#0x2700,%sr
		move.w		GreyscalePhase,%d0
		beq		Greyscale_HW2_Wrap
		subq.w		#2,%d0
		move.w		%d0,GreyscalePhase
		lea		GreyscaleData,%a1
		move.l		GreyPlane,%a0
		add.w		0(%a1,%d0.w),%a0
		lea		0x00004c00,%a1
		move.w		#79,%d0
	Greyscale_HW2_Loop:
		movem.l		(%a0)+,%a2-%a6/%d1-%d7
		movem.l		%a2-%a6/%d1-%d7,(%a1)
		add.w		#48,%a1
		dbra		%d0,Greyscale_HW2_Loop
		bra		Greyscale_HW2_Done
	Greyscale_HW2_Wrap:
		move.w		#2*2,GreyscalePhase
	Greyscale_HW2_Done:
		movem.l		(%sp)+,%a0-%a6/%d0-%d7
		rte");


/*****************
* HIGHSCORE CODE *
*****************/
void view_highscores(void) {
  int i;
  HANDLE dhandle = DialogNewSimple(8+6*16+6*NUMBER_WIDTH,17+NO_OF_HISCORES*FONT_HEIGHT+4+FONT_HEIGHT); 
  char *num,title[sizeof(LANG_NORMAL)+sizeof(LANG_PUZZLE)+3+
                  sizeof(LANG_MODE_PREV)+sizeof(LANG_MODE_POST)+
                  sizeof(LANG_SIZE_PREV)+sizeof(LANG_SIZE_POST)];

  sprintf(title,LANG_HIGHSCORE_TITLE,OptionsModePopup_Main_Entry1Str + sizeof(LANG_PUZZLE)*Mode.playmode,
          OptionsSizePopup_Main_Entry1Str + sizeof(LANG_NORMAL)*Mode.stonesize);

  DialogAddTitle(dhandle,title,BT_NONE,BT_OK);
  for(i=0 ; i<NO_OF_HISCORES ; i++) {
    DialogAddText(dhandle,3,13+i*FONT_HEIGHT,highscores[Mode.stonesize][i].name);
    num = ulsprintf(title+7,highscores[Mode.stonesize][i].score);
    DialogAddText(dhandle,1+6*16+6*NUMBER_WIDTH-DrawStrWidth(num,FONT),13+i*FONT_HEIGHT,num);
  }
  DialogDo(dhandle,CENTER,CENTER,NULL,NULL);

  HeapFree(dhandle);
}

void check_add_highscore(unsigned long score) {
  int newPlace = 0;

  while((newPlace < 5) && (score <= highscores[Mode.stonesize][newPlace].score))
    newPlace++;

  if(newPlace < 5) {
    int i;

    for(i=4 ; i>newPlace ; i--) {
      strcpy(highscores[Mode.stonesize][i].name,highscores[Mode.stonesize][i-1].name);
      highscores[Mode.stonesize][i].score = highscores[Mode.stonesize][i-1].score;
    }
    highscores[Mode.stonesize][newPlace].score = score;
    highscores[Mode.stonesize][newPlace].name[0] = '\0';
    Dialog(&NewHighscoreDlg,CENTER,CENTER,highscores[Mode.stonesize][newPlace].name,NULL);
    view_highscores();
  }
  else {
    DlgMessage(LANG_SORRY,LANG_NO_NEW_HIGHSCORE,BT_NONE,BT_OK); 
  }
}


/************
* GAME CODE *
************/
void play_game(void) {
  SCR_STATE ScreenState;
  void *OldInt5Address;
  int done=0;
  unsigned char playfield[MAX_PLAYFIELD_HEIGHT][MAX_PLAYFIELD_WIDTH];
  unsigned long score = 0;
  int x = 0, y = 0;
  unsigned int PlayfieldWidth = LCD_WIDTH/(stones[Mode.stonesize].size+1);
  unsigned int PlayfieldHeight = (LCD_HEIGHT-8)/(stones[Mode.stonesize].size+1);
  unsigned int maxcol = PlayfieldWidth;
  unsigned int size = stones[Mode.stonesize].size;
  unsigned int spacing = stones[Mode.stonesize].size+1;
  BYTE *data = stones[Mode.stonesize].data;
  unsigned int starty = LCD_HEIGHT-8-PlayfieldHeight*spacing;
  unsigned int startx = (LCD_WIDTH-PlayfieldWidth*spacing) >> 1;

  inline void SetGreyPlane(int plane) {
    PortSet(GreyPlane[plane],239,127);
  }

  void PlotPiece(int x, int y, int c) {
    x = x*spacing + startx;
    y = y*spacing + starty;
    asm("  move.l	#-1,%%d6
           move.w	(%0)+,%%d6
           rol.l	%1,%%d6
         PlotPieceLoop:
           moveq	#0,%%d7
           move.w	(%0)+,%%d7
           lsl.l	%1,%%d7
           and.l	%%d6,(%2)
           btst.b	#1,%4
           beq		PlotPiece_NoPlane0
           or.l		%%d7,(%2)
         PlotPiece_NoPlane0:
           and.l	%%d6,3840(%2)
           btst.b	#0,%4
           beq		PlotPiece_NoPlane1
           or.l		%%d7,3840(%2)
         PlotPiece_NoPlane1:
           add.w	#30,%2
           dbra		%3,PlotPieceLoop" : :
           "a" (data),
           "d" (16 - (x & 0x000f)),
           "a" (GreyPlane[0] + 30*y + ((x >> 3) & 0xfffe)),
           "d" (size-1),
           "d" (c) : "d6","d7");
  }

  void PlotCursor(int x, int y) {
    x = x*spacing + startx;
    y = y*spacing + starty;
    asm("PlotCursorLoop:
           moveq	#0,%%d7
           move.w	(%0)+,%%d7
           lsl.l	%1,%%d7
           eor.l	%%d7,(%2)
           eor.l	%%d7,3840(%2)
           eor.l	%%d7,(%3)
           eor.l	%%d7,3840(%3)
           add.w	#30,%2
           sub.w	#30,%3
           dbra		%4,PlotCursorLoop" : :
           "a" ((BYTE *)data+2*size+2),
           "d" (16 - (x & 0x000f)),
           "a" (GreyPlane[0] + 30*y + ((x >> 3) & 0xfffe)),
           "a" (GreyPlane[0] + 30*(y+size-1) + ((x >> 3) & 0xfffe)),
           "d" ((size >> 1)-1) : "d7");
  }

  void plot_playfield(void) {
    int row,col;

    for(row=PlayfieldHeight-1 ; row>=0 ; row--) {
      for(col=PlayfieldWidth-1 ; col>=0 ; col--) {
        PlotPiece(col,row,playfield[row][col]);
      }
    }
  }

  void plot_score(void) {
    char buffer[8],*num;
    int plane;
    num = ulsprintf(buffer+7,score);
    for(plane=0 ; plane<2 ; plane++) {
      SetGreyPlane(plane);
      DrawStrXY(LCD_WIDTH-3-DrawStrWidth(num,0),LCD_HEIGHT-6,num,A_REPLACE);
    }
  }

  int neighbours(int nx,int ny) {
    int c=playfield[ny][nx],count=0;
    if(c > 0) {
      if((nx>0) && (playfield[ny][nx-1] == c))
        count++;
      if((nx<maxcol-1) && (playfield[ny][nx+1] == c))
        count++;
      if((ny>0) && (playfield[ny-1][nx] == c))
        count++;
      if((ny<PlayfieldHeight-1) && (playfield[ny+1][nx] == c))
        count++;
    }
    return count;
  }

  BOOL no_more_combinations(void) {
    int row,col;

    for(col=maxcol-1 ; col>=0 ; col--) {
      for(row=PlayfieldHeight-1 ; row>=0 ; row--) {
        if(playfield[row][col] &&
           (((col < PlayfieldWidth-1) && (playfield[row][col+1] == playfield[row][col])) ||
            ((row < PlayfieldHeight-1) && (playfield[row+1][col] == playfield[row][col]))))
          return FALSE;
      }
    }
    return TRUE;
  }

  unsigned long remove_pieces(int x,int y, int c) {
    if(playfield[y][x] == c) {
      unsigned long count=1;
      playfield[y][x] = 0;
      if(x>0)
        count += remove_pieces(x-1,y,c);
      if(x<maxcol-1)
        count += remove_pieces(x+1,y,c);
      if(y>0)
        count += remove_pieces(x,y-1,c);
      if(y<PlayfieldHeight-1)
        count += remove_pieces(x,y+1,c);
      return count;
    }
    else {
      return 0;
    }
  }

  void fix_playfield(void) {
    int col,col2,row,rowdisp;

    for(col=maxcol-1 ; col>=0 ; col--) {
      rowdisp = 0;
      for(row=PlayfieldHeight-1 ; row>=0 ; row--) {
        if(playfield[row][col] == 0) {
          rowdisp++;
        }
        else if(rowdisp){
          playfield[row+rowdisp][col] = playfield[row][col];
          playfield[row][col] = 0;
        }
      }
      if(rowdisp == PlayfieldHeight) {
        maxcol--;
        for(row=PlayfieldHeight-1 ; row>=0 ; row--) {
          for(col2=col ; col2<maxcol ; col2++)
            playfield[row][col2] = playfield[row][col2+1];
          playfield[row][maxcol] = 0;
        }
      }
    }
  }

  SaveScrState(&ScreenState);
  asm("		move.w		#0x0700,%%d0
		trap		#1
		move.l		(0x00000074),%0
		bclr.b		#2,(0x00600001)
		cmp.w		#1,HW
		beq.s		SetHW1
		lea		GreyscaleInterrupt_HW2,%%a0
		bra		SetHW_Done
	SetHW1:
		lea		GreyscaleInterrupt_HW1,%%a0
	SetHW_Done:
		move.l		%%a0,(0x00000074)
		bset.b		#2,(0x00600001)
		trap		#1
		move.b		#0xf1,(0x00600017)" : "=d" (OldInt5Address) : : "a0","d0");
  FontSetSys(0);

  for(y=0 ; y<2 ; y++) {
    SetGreyPlane(y);
    ClrScr();
    DrawLine(0,LCD_HEIGHT-8,LCD_WIDTH-1,LCD_HEIGHT-8,A_NORMAL);
    DrawStrXY(0,LCD_HEIGHT-6,MainMenu_Title,A_NORMAL);
  }

  for(y=PlayfieldHeight-1 ; y>=0 ; y--) {
    for(x=PlayfieldWidth-1 ; x>=0 ; x--) {
      playfield[y][x] = 1 + rand(3);
    }
  }
  x = PlayfieldWidth/2;
  y = PlayfieldHeight/2;
  score = 0;

  plot_score();
  plot_playfield();
  PlotCursor(x,y);

  while(!done) {
    switch(ngetchx()) {
    case BUTTON_LEFT:
      if(x>0) {
        PlotCursor(x--,y);
        PlotCursor(x,y);
      }
      break;
    case BUTTON_RIGHT:
      if(x<PlayfieldWidth-1) {
        PlotCursor(x++,y);
        PlotCursor(x,y);
      }
      break;
    case BUTTON_UP:
      if(y>0) {
        PlotCursor(x,y--);
        PlotCursor(x,y);
      }
      break;
    case BUTTON_DOWN:
      if(y<PlayfieldHeight-1) {
        PlotCursor(x,y++);
        PlotCursor(x,y);
      }
      break;
    case BUTTON_ESC:
      done = 1;
      break;
    case BUTTON_ACTION:
      if(neighbours(x,y) > 0) {
        unsigned int removed = remove_pieces(x,y,playfield[y][x]);
        if(removed > 0) {
          fix_playfield();
          plot_playfield();
          PlotCursor(x,y);
          if(removed > 2)
            score += (ULONG)(removed-2)*(removed-2);
            plot_score();
          if(no_more_combinations()) {
            done = 2;
            if(playfield[PlayfieldHeight-1][0] == 0) {
              removed = (PlayfieldWidth*PlayfieldHeight >> 2) - 2;
              score += (ULONG)(removed-2)*(removed-2);
            }
          }
        }
      }
      break;
    }
  }

  // Unhook the greyscale interrupt and restore the old LCD address.
  asm("	move.w		#0x0700,%%d0
	trap		#1
	bclr.b		#2,(0x00600001)
	move.l		%1,(0x00000074)
	bset.b		#2,(0x00600001)
	move.w		#0x0000,%%d0
	trap		#1
	move.w		%0,(0x00600010)
	move.b		#0xb2,(0x00600017)" : : "d" ((ULONG)ScreenState.ScrAddr >> 3), "d" (OldInt5Address)  : "d0");
  RestoreScrState(&ScreenState);

  // If we are running on HW2 we need to restore the current LCD contents.
  if(HW == 2)
    memcpy((void *)0x4c00,(void *)GreyPlane[1] + 30*128,3840); 

  if(done == 2)
    check_add_highscore(score);
}

/***************
* MAIN PROGRAM *
***************/
int _main(void) {
  HANDLE GreyHandle;
  unsigned int choice = 0;
  BOOL Running = TRUE;
  HW = (unsigned int)GetHardwareVersion();

  // Allocate memory for the greyscale double buffer.
  // We need:
  //  2 planes with 30*128 bytes, aligned to the nearest 8 byte (actual LCD display memory)
  //  2 extra bytes for the CopyBufferToLCD routine.
  //  2 planes with 32*128 bytes (LCD buffer with clipping word)
  GreyHandle = HeapAllocHigh(8+(1+HW)*128*30);

  // Check to see if we got the memory.
  if(!GreyHandle) {
    DlgMessage(LANG_ERROR,LANG_NOT_ENOUGH_MEMORY,BT_NONE,BT_OK);
    return 1;
  }

  // Setup the greyscale bitplanes.
  HeapLock(GreyHandle);
  GreyPlane[0] = (void *)((ULONG)((void *)HeapDeref(GreyHandle) + 7) & 0xfffffff8);
  GreyPlane[1] = (void *)GreyPlane[0] + 30*128;
  GreyscalePhase = 0;

  // The greyscale data is different depending on what HW version we are running on.
  // If HW1 we just store the addresses of the bitplaned divided by 8.
  if(HW == 1) {
    GreyscaleData[1] = ((ULONG)GreyPlane[0] >> 3);
    GreyscaleData[0] = GreyscaleData[1] + 30*128/8;
  }
  // If HW2 we store the offset in the greyscale data. We also need to store the
  // current LCD data since we'll overwrite it later.
  else {
    memcpy((void *)GreyPlane[1] + 30*128,(void *)0x4c00,3840); 
    GreyscaleData[1] = 0;
    GreyscaleData[0] = 3840;
  }

  while(Running) {
    GKeyFlush();
    switch(choice = MenuPopup(&MainMenuPopup,CENTER,CENTER,choice)) {
    case MAINMENU_NEWGAME:
      play_game();
      break;
    case MAINMENU_OPTIONS:
      Mode.stonesize++;
      Mode.playmode++;
      Dialog(&OptionsDlg,CENTER,CENTER,NULL,(int *)&Mode); 
      Mode.stonesize--;
      Mode.playmode--;
      break;
    case MAINMENU_HIGHSCORES:
      view_highscores();
      break;
    case MAINMENU_ABOUT:
      Dialog(&AboutDlg,CENTER,CENTER,NULL,NULL); 
      break;
    case MAINMENU_ESC:
    case MAINMENU_QUIT:
      Running = FALSE;
      break;
    }
  }

  HeapFree(GreyHandle);
  GKeyFlush();
  return 0;
}
